const N = ...;
type things = ...; (* anything comparable by (generalized) '<' *)
     listofdata = array [1..N] of things;
function binarysearch (var (* for speed *) A: listofdata; last: integer,
                       var k: things): integer;
  (* Return location in A of k, if present, or 0 if absent.
     last is the location of the last valid datum in A. *)
  label 1;
  type order = (less,equal,greater);
  var l,m,r: integer;
      (* left, middle and right.
         The value k, if present, is always located in A[l..r] *)
  function comparison (var first,second: things): order;
    begin
      (* Determine if first is "less", "equal", or "greater" wrt second. *)
      ...
    end;
  begin (* binarysearch *)
    l := 1; (* If present surely in A[l..r] at this point *)
    r := last;
    while l <= r do (* There still is a potential range *)
      begin
        (* Find the middle element of A[l..r], more or less *)
        m := (l+r) div 2;
        case comparison(k,A[m]) of
          less:    r := m-1; (* If present, then to the left of m *)
          equal:   begin (* found it *)
                     binarysearch := m;
                     goto 1 (* return *)
                   end;
          greater: l := m+1 (* If present, then to the right of m *)
        end (* case *)
      end; (* while *)
    (* Not present in the list *)
    binarysearch := 0;
  1:
  end;
